#include <OneWire.h>
#include <ESP8266WiFi.h>
#include <PubSubClient.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <math.h>
int MUXPinS0 = D7;
int MUXPinS1 = D6;
int MUXPinS2 = D5;
int MUXPinS3 = D4;
LiquidCrystal_I2C lcd(0x27,20,4);
#define ONE_WIRE_BUS 0
const int flowPin1 = D0;
const int flowPin2 = D8;

//// NTC themrestistor setting ///
int Ro = 10, B =  3950; // Ro is Nominal resistance @ 25c 
int Rseries = 10;// Series resistor 10K
float To = 298.15; // Nominal Temperature of 25C ( kelvin) 
//analog ports
int A_1 =0;
int A_2 =4;
int A_3 =8;
int A_4 =12;

float Tc1 =0; // NTC 10  sensors 1-4
float Tc2 =0;
float Tc3 =0;
float Tc4 =0;
int sample = 50;

int COLLECTD = 1; // set to 0 to disable, 1 to enable
//topic for collectd 
const char* HP_T1 = "incoming/test/mqtt-Energy/temperature-HPT1";  // 
const char* HP_T2 = "incoming/test/mqtt-Energy/temperature-HPT2";
const char* HP_F1 = "incoming/test/mqtt-Energy/flow-HPF1";
const char* HP_W1 = "incoming/test/mqtt-Energy/power-HPWatts1";
const char* HP_T3 = "incoming/test/mqtt-Energy/temperature-HPT3";  // 
const char* HP_T4 = "incoming/test/mqtt-Energy/temperature-HPT4";
const char* HP_F2 = "incoming/test/mqtt-Energy/flow-HPF2";
const char* HP_W2 = "incoming/test/mqtt-Energy/power-HPWatts2";
const char* HP_T5 = "incoming/test/mqtt-Energy/temperature";

// domoticz
int DOMOTICZ =1; // set to 0 to disable, 1 to enable
const char* domoticz_server = "192.168.168.251"; //Domoticz port
 int port = 8080; //Domoticz port
 int idx1 = 97; // temp1 IDX for this virtual sensor, found in Setup -> Devices
 int idx2 = 98; //temp2 for this virtual sensor, found in Setup -> Devices
 int idx3 = 99; //flow1 for this virtual sensor, found in Setup -> Devices
 int idx4 = 100; //power1 for this virtual sensor, found in Setup -> Devices
 int idx5 = 101; //temp3 for this virtual sensor, found in Setup -> Devices
 int idx6 = 102; //temp4 for this virtual sensor, found in Setup -> Devices
 int idx7 = 103; //flow2 for this virtual sensor, found in Setup -> Devices
 int idx8 = 104; //power2 for this virtual sensor, found in Setup -> Devices

// Update these with values suitable for your network.
const char* ssid = "IOT";
const char* password = "";
const char* mqtt_server = "192.168.168.150";

WiFiClient domoticz1;

////////////////////////////////////
PubSubClient client(domoticz1);
long lastMsg = 0;
char msg[50];
OneWire ds(ONE_WIRE_BUS);
char data[80];
char Topic[80];
unsigned long flow1count = 0;
unsigned long flowacount = 0;
unsigned long flow2count = 0;
unsigned long flowbcount = 0;
float dt = 0;
float dt2 =0;
float t1 = 0;
float t2 = 0;
float t3 = 0;
float t4 = 0;
int cnt = 0;
int cnt2 = 0;
float dta =0;
float dt2a =0;
float w =0;
float w2=0;
float fa=0;
float fb=0;
int INFO = 1;
int span =5;
///////////////////////////////


void setup() 
{
  Serial.begin(115200);
  lcd.init();
  // Print a message to the LCD.
  lcd.backlight();
  lcd.setCursor(3,0);
  lcd.print("Flow Meter");
  lcd.setCursor(2,1);
  lcd.print("By krywenko");
  
  pinMode(MUXPinS0, OUTPUT);
  pinMode(MUXPinS1, OUTPUT);
  pinMode(MUXPinS2, OUTPUT);
  pinMode(MUXPinS3, OUTPUT);
  pinMode(flowPin1, INPUT);
  attachInterrupt(flowPin1, flow1, CHANGE);
  pinMode(flowPin2, INPUT);
  attachInterrupt(flowPin2, flow2, CHANGE);
 
  pinMode(BUILTIN_LED, OUTPUT);     // Initialize the BUILTIN_LED pin as an output
 
  Serial.println("");
  Sensor();
  INFO = 0;    // Sensor  - set extra info to not display
  delay(1000);
  
  setup_wifi();
 
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
  
}


void setup_wifi() {

  delay(10);
  // We start by connecting to a WiFi network
  Serial.println();
  lcd.init();
  lcd.clear();
  lcd.print("  Connecting to");
  lcd.setCursor(2,1);
  lcd.print(ssid);
  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("IP ");
  lcd.setCursor(0,1);
  lcd.print(WiFi.localIP());
  delay(2000);
}


void callback(char* topic, byte* payload, unsigned int length) {
  Serial.print("Message arrived [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i = 0; i < length; i++) {
    Serial.print((char)payload[i]);
  }
  Serial.println();

  // Switch on the LED if an 1 was received as first character
  if ((char)payload[0] == '1') {
    digitalWrite(BUILTIN_LED, LOW);   // Turn the LED on (Note that LOW is the voltage level
    // but actually the LED is on; this is because
    // it is acive low on the ESP-01)
  } else {
    digitalWrite(BUILTIN_LED, HIGH);  // Turn the LED off by making the voltage HIGH
  }

}


void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {

    Serial.print("Attempting MQTT connection...");
    // Attempt to connect
    if (client.connect("DomoticzDevice1")) {
      Serial.println("connected");
      // Once connected, publish an announcement...
      client.publish("outTopic", "hello world");
      // ... and resubscribe
      client.subscribe("inTopic");
    } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      
      delay(5000);
    }
  }

}


void loop(){ 
cnt++;
  if (!client.connected()) {
    reconnect();
  }

  client.loop();

 THERMO();

  t1 = (Tc1 + 0.0);  //add error correction or adjust resistors in void THERMO()
  t2 = (Tc2 + 0.0);
  dt = (t1 - t2); 
  dta= (dta+dt); 

  t3 = (Tc3 + 0.00);  //add error correction
  t4 = (Tc4 + 0.00);
  dt2 = (t3 - t4);
  dt2a=(dt2a+dt2);
  //Serial.println( Tc1, 3 );
  //Serial.println( Tc2, 3 );
  //Serial.println( Tc3, 3 );
  //Serial.println( Tc4, 3 );
  //Serial.println(" "); 
  long now = millis();
 
  if (now - lastMsg > (1000*span)) {   // 5 second sample
    lastMsg = now; 
    
    fa =((flowacount/450.0)/span);  //flow rate calulated at l/s
    fb=((flowbcount/450.0)/span);
    dta=(dta/cnt);
    dt2a=(dt2a/cnt);
    
    w=(((((flowacount/450.0)*1000)*dta)*4.188)/span);     // adjust last to match inteval of sampling sec
  
    w2=(((((flowbcount/450.0)*1000)*dt2a)*4.188)/span);
 
  Collectd();
  Domoticz();
  Sensor();
  flowacount =0;
  flowbcount =0; 
  cnt=0;
  dta=0;
  dt2a=0; 
}
  Tc1 = 0; // resets thermo sampling  
  Tc2 = 0;
  Tc3 = 0;
  Tc4 = 0;
}
 
void Collectd(){
 //collectd
if (COLLECTD ==1) {

String Value = "N:" + String(t1);
String payload3 = Value;
payload3.toCharArray(data, (payload3.length() + 1));
Serial.print(HP_T1);
Serial.print(" ");
Serial.println( data);
client.publish(HP_T1,data);

Value = "N:" + String(t2);
payload3 = Value;
payload3.toCharArray(data, (payload3.length() + 1));
Serial.print(HP_T2);
Serial.print(" ");
Serial.println( data);
client.publish(HP_T2,data);

Value = "N:" + String(fa);
payload3 = Value;
payload3.toCharArray(data, (payload3.length() + 1));
Serial.print(HP_F1);
Serial.print(" ");
Serial.println( data);
client.publish(HP_F1,data);

Value = "N:" + String(w);
payload3 = Value;
payload3.toCharArray(data, (payload3.length() + 1));
Serial.print(HP_W1);
Serial.print(" ");
Serial.println( data);
client.publish(HP_W1,data);

Value = "N:" + String(t3);
payload3 = Value;
payload3.toCharArray(data, (payload3.length() + 1));
Serial.print(HP_T3);
Serial.print(" ");
Serial.println( data);
client.publish(HP_T3,data);

Value = "N:" + String(t4);
payload3 = Value;
payload3.toCharArray(data, (payload3.length() + 1));
Serial.print(HP_T4);
Serial.print(" ");
Serial.println( data);
client.publish(HP_T4,data);

Value = "N:" + String(fb);
payload3 = Value;
payload3.toCharArray(data, (payload3.length() + 1));
Serial.print(HP_F2);
Serial.print(" ");
Serial.println( data);
client.publish(HP_F2,data);

Value = "N:" + String(w2);
payload3 = Value;
payload3.toCharArray(data, (payload3.length() + 1));
Serial.print(HP_W2);
Serial.print(" ");
Serial.println( data);
client.publish(HP_W2,data);

Serial.println("Published to CollectD: ");
}
return; 
}


void Domoticz(){
 if (DOMOTICZ == 1) {

// Domoticz format /json.htm?type=command&param=udevice&idx=IDX&nvalue=0&svalue=TEMP1;TEMP2;FLOW;POWER
   Serial.print("IDX ");
    if (domoticz1.connect(domoticz_server,port)) {

        domoticz1.print("GET /json.htm?type=command&param=udevice&idx=");
        domoticz1.print(idx1);
        domoticz1.print("&nvalue=0&svalue=");
        domoticz1.print(t1);
        domoticz1.println(" HTTP/1.1");
        domoticz1.print("Host: ");
        domoticz1.print(domoticz_server);
        domoticz1.print(":");
        domoticz1.println(port);
        domoticz1.println("User-Agent: Arduino-ethernet");
        domoticz1.println("Connection: close");
        domoticz1.println();
        domoticz1.stop();
        Serial.print("1 ");
        delay(10);
     }
    if (domoticz1.connect(domoticz_server,port)) {

        domoticz1.print("GET /json.htm?type=command&param=udevice&idx=");
        domoticz1.print(idx2);
        domoticz1.print("&nvalue=1&svalue=");
        domoticz1.print(t2);
        domoticz1.println(" HTTP/1.1");
        domoticz1.print("Host: ");
        domoticz1.print(domoticz_server);
        domoticz1.print(":");
        domoticz1.println(port);
        domoticz1.println("User-Agent: Arduino-ethernet");
        domoticz1.println("Connection: close");
        domoticz1.println();
        domoticz1.stop();
        Serial.print("2 ");
        delay(10);
     }

     if (domoticz1.connect(domoticz_server,port)) {

        domoticz1.print("GET /json.htm?type=command&param=udevice&idx=");
        domoticz1.print(idx3);
        domoticz1.print("&nvalue=0&svalue=");
        domoticz1.print(fa);
        domoticz1.println(" HTTP/1.1");
        domoticz1.print("Host: ");
        domoticz1.print(domoticz_server);
        domoticz1.print(":");
        domoticz1.println(port);
        domoticz1.println("User-Agent: Arduino-ethernet");
        domoticz1.println("Connection: close");
        domoticz1.println();
        domoticz1.stop();
        Serial.print("3 ");
        delay(10);
     }

     if (domoticz1.connect(domoticz_server,port)) {

        domoticz1.print("GET /json.htm?type=command&param=udevice&idx=");
        domoticz1.print(idx4);
        domoticz1.print("&nvalue=0&svalue=");
        domoticz1.print(w);
        domoticz1.println(" HTTP/1.1");
        domoticz1.print("Host: ");
        domoticz1.print(domoticz_server);
        domoticz1.print(":");
        domoticz1.println(port);
        domoticz1.println("User-Agent: Arduino-ethernet");
        domoticz1.println("Connection: close");
        domoticz1.println();
        domoticz1.stop();
        Serial.print("4 ");
        delay(10);
     }

     if (domoticz1.connect(domoticz_server,port)) {

        domoticz1.print("GET /json.htm?type=command&param=udevice&idx=");
        domoticz1.print(idx5);
        domoticz1.print("&nvalue=0&svalue=");
        domoticz1.print(t3);
        domoticz1.println(" HTTP/1.1");
        domoticz1.print("Host: ");
        domoticz1.print(domoticz_server);
        domoticz1.print(":");
        domoticz1.println(port);
        domoticz1.println("User-Agent: Arduino-ethernet");
        domoticz1.println("Connection: close");
        domoticz1.println();
        domoticz1.stop();
        Serial.print("5 ");
        delay(10);
     }

     if (domoticz1.connect(domoticz_server,port)) {

        domoticz1.print("GET /json.htm?type=command&param=udevice&idx=");
        domoticz1.print(idx6);
        domoticz1.print("&nvalue=0&svalue=");
        domoticz1.print(t4);
        domoticz1.println(" HTTP/1.1");
        domoticz1.print("Host: ");
        domoticz1.print(domoticz_server);
        domoticz1.print(":");
        domoticz1.println(port);
        domoticz1.println("User-Agent: Arduino-ethernet");
        domoticz1.println("Connection: close");
        domoticz1.println();
        domoticz1.stop();
        Serial.print("6 ");
        delay(10);
     }

     if (domoticz1.connect(domoticz_server,port)) {

        domoticz1.print("GET /json.htm?type=command&param=udevice&idx=");
        domoticz1.print(idx7);
        domoticz1.print("&nvalue=0&svalue=");
        domoticz1.print(fb);
        domoticz1.println(" HTTP/1.1");
        domoticz1.print("Host: ");
        domoticz1.print(domoticz_server);
        domoticz1.print(":");
        domoticz1.println(port);
        domoticz1.println("User-Agent: Arduino-ethernet");
        domoticz1.println("Connection: close");
        domoticz1.println();
        domoticz1.stop();
        Serial.print("7 ");
        delay(10);
     }

     if (domoticz1.connect(domoticz_server,port)) {

        domoticz1.print("GET /json.htm?type=command&param=udevice&idx=");
        domoticz1.print(idx8);
        domoticz1.print("&nvalue=0&svalue=");
        domoticz1.print(w2);
        domoticz1.println(" HTTP/1.1");
        domoticz1.print("Host: ");
        domoticz1.print(domoticz_server);
        domoticz1.print(":");
        domoticz1.println(port);
        domoticz1.println("User-Agent: Arduino-ethernet");
        domoticz1.println("Connection: close");
        domoticz1.println();
        domoticz1.stop();
        Serial.print("8 ");
        delay(10);
     }
     Serial.println("Sent to domoticz ");
  } 
  return;
}

void flow1(){
flow1count +=1;
flowacount +=1;
}

void flow2(){
flow2count +=1;
flowbcount +=1;
}


void THERMO() {
   for (int i = 0; i <= sample; i++) {
  //Read analog outputof NTC module,
  // i.e the voltage across the thermistor 
  float Vi = getAnalog(A_1) * (5.0 / 1023.0);
  //Convert voltage measured to resistance value
  //All Resistance are in kilo ohms.
  float R = (Vi * Rseries) / (5 - Vi);
  //Use R value in steinhart and hart equation
   // Calculate temperature value in kelvin
  float T =  1 / ((1 / To) + ((log(R / Ro)) / B));
  float TcA = T - 273.15; // Converting kelvin to celsius
  Tc1 = Tc1+TcA;

  Vi = getAnalog(A_2) * (5.0 / 1023.0);
  R = (Vi * Rseries) / (5 - Vi);
  T =  1 / ((1 / To) + ((log(R / Ro)) / B));
  float TcB = T - 273.15; // Converting kelvin to celsius
  Tc2 = Tc2+TcB;

  Vi = getAnalog(A_3) * (5.0 / 1023.0);
  R = (Vi * Rseries) / (5 - Vi);
   T =  1 / ((1 / To) + ((log(R / Ro)) / B));
  float TcC = T - 273.15; // Converting kelvin to celsius
  Tc3 = Tc3+TcC;

  Vi = getAnalog(A_4) * (5.0 / 1023.0);
  R = (Vi * Rseries) / (5 - Vi);
  T =  1 / ((1 / To) + ((log(R / Ro)) / B));
  float TcD = T - 273.15; // Converting kelvin to celsius
  Tc4 = Tc4+TcD;

  }

  Tc1 = Tc1/sample;
  Tc2 = Tc2/sample;
  Tc3 = Tc3/sample;
  Tc4 = Tc4/sample; 
return;
}

float getAnalog(int MUXyPin) {
  //MUXyPin must be 0 to 15 representing the analog pin you want to read
  //MUXPinS3 to MUXPinS0 are the Arduino pins connected to the selector pins of this board.
  digitalWrite(MUXPinS3, HIGH && (MUXyPin & B00001000));
  digitalWrite(MUXPinS2, HIGH && (MUXyPin & B00000100));
  digitalWrite(MUXPinS1, HIGH && (MUXyPin & B00000010));
  digitalWrite(MUXPinS0, HIGH && (MUXyPin & B00000001));
  return (float)analogRead(A0);
}

void Sensor() {
  byte i;
  byte present = 0;
  byte type_s;
  byte data[12];
  byte addr[8];
  
//Loop through all DS1820
while(ds.search(addr))
{ 
//Topic is built from a static String plus the ID of the DS18B20
  String romcode = "";
  
  for( i = 0; i < 8; i++) {
    //Serial.write(' ');
   // Serial.print(addr[i], HEX);
    
     romcode = romcode + String(addr[i], HEX);
    
  }
  Serial.print(romcode);
  Serial.print(" ");

  if (OneWire::crc8(addr, 7) != addr[7]) {
      Serial.println("CRC is not valid!");
      return;
  }
// the first ROM byte indicates which chip
  switch (addr[0]) {
    case 0x10:
      if ( INFO == 1){Serial.println("  Chip = DS18S20"); } // or old DS1820
      type_s = 1;
      break;
    case 0x28:
     if ( INFO == 1){ Serial.println("  Chip = DS18B20");}
      type_s = 0;
      break;
    case 0x22:
      if ( INFO == 1){Serial.println("  Chip = DS1822");}
      type_s = 0;
      break;
    default:
      if ( INFO == 1){Serial.println("Device is not a DS18x20 family device.");}
      return;
  } 

  ds.reset();
  ds.select(addr);
  ds.write(0x44, 1);        // start conversion, with parasite power on at the end
  
  delay(100);     // maybe 750ms is enough, maybe not
  // we might do a ds.depower() here, but the reset will take care of it.
  
  present = ds.reset();
  ds.select(addr);    
  ds.write(0xBE);         // Read Scratchpad

  //Serial.print("  Data = ");
  //Serial.print(present, HEX);
  //Serial.print(" ");
  for ( i = 0; i < 9; i++) {           // we need 9 bytes
    data[i] = ds.read();
    //Serial.print(data[i], HEX);
    //Serial.print(" ");
  }
  //Serial.print(" CRC=");
  //Serial.print(OneWire::crc8(data, 8), HEX);
  //Serial.println();

  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) {
    raw = raw << 3; // 9 bit resolution default
    if (data[7] == 0x10) {
      // "count remain" gives full 12 bit resolution
      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  } else {
    byte cfg = (data[4] & 0x60);
    // at lower res, the low bits are undefined, so let's zero them
    if (cfg == 0x00) raw = raw & ~7;  // 9 bit resolution, 93.75 ms
    else if (cfg == 0x20) raw = raw & ~3; // 10 bit res, 187.5 ms
    else if (cfg == 0x40) raw = raw & ~1; // 11 bit res, 375 ms
    //// default is 12 bit resolution, 750 ms conversion time
  }

//convert RAW Temperature to String
String raw_temp = String(raw, DEC);
float tempc=(raw_temp.toFloat());
tempc=(tempc/16);
raw_temp=tempc;
Serial.println(tempc);
if ( INFO == 0){
if (tempc <= 125 && tempc >= -55) { //if  {
Serial.println(tempc);
     cnt2++;
    if (cnt2 == 5) { 
      Serial.print("not listed ");
    if (client.publish((char*) romcode.c_str(), (char*) raw_temp.c_str())) {
      Serial.print((char*) romcode.c_str());
      Serial.print(" ");
      Serial.print((char*) raw_temp.c_str());
      Serial.println(" Publish ok");
      cnt2 =0;
    }
    else {
      Serial.print((char*) romcode.c_str());
      Serial.println(" Failed to Publish");
      cnt2 =0;
    }}

}
else { Serial.println(" invalid");}//}
 
}  //delay(5000);
}
//End of the OneWire-Devices, reset Loop
Serial.println("End of Onewire Bus");
ds.reset_search();
return;
}

// -- END OF FILE --
